import com.vividsolutions.jump.workbench.plugin.AbstractPlugIn;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.*;
import com.vividsolutions.jump.feature.*;
import com.vividsolutions.jts.geom.*;
import java.util.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.awt.Component;
import com.vividsolutions.jump.workbench.ui.*;
import com.vividsolutions.jump.io.*;
import com.vividsolutions.jump.workbench.model.*;
import com.vividsolutions.jts.geom.GeometryFactory.*;

// PlugIn pro OJ, kter zobraz dialoov okno pro vbr souboru a po vybrn shapefilu pid vrstvu do OJ

public class NactiShpPlugIn extends AbstractPlugIn {
   
    
 public void initialize(PlugInContext context){
        context.getFeatureInstaller().addMainMenuItem(this, new String[] { "Nstroje", "Vyber soubor" }, getName(), false, null, null);
    }
    
    public boolean execute(PlugInContext context) throws Exception {   
       
           String fname = this.nahraj(context);  //zavolme metodu nahraj, kter nm ulo do promnn fname cestu k vybranmu shapefilu
        
                  
           // dialogov okno, kter vype cestu k vybranmu souboru
                  MultiInputDialog dialog = new MultiInputDialog(context.getWorkbenchFrame(),getName(),true);
                  dialog.addLabel(fname);
                  GUIUtil.centreOnWindow(dialog);
                  dialog.setVisible(true);
                                   
             
             ShapefileReader reader = new ShapefileReader();                   //vytvome nov objekt ShapefileReader s nzvem reader
             FeatureCollection fc = reader.read(new DriverProperties(fname));  //nateme do promnn fc FeatureCollection z vybranho shapefile pomoc objektu reader a metody read
             //List<Feature> features = fc.getFeatures();                       
                              
             context.addLayer(StandardCategoryNames.RESULT, "myLayerName" , fc );   //pidme do OJ novou Layer
                              
          return true;           
           
           
 }
 
 
 // metoda nahraj, kter vrac cestu k vybrannmu souboru; podrobnj popis v Pluginu: vyberSoubor.jar
   public String nahraj(PlugInContext context) throws Exception {   
   String fname = "";        
        JFileChooser chooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Shapefile", "shp", "SHP");
        chooser.setFileFilter(filter);       
        chooser.setDialogTitle("Vyber soubor");
        Component parent = context.getWorkbenchFrame();
        int returnVal = chooser.showOpenDialog(parent);      
        if(returnVal == JFileChooser.APPROVE_OPTION) {
                fname = chooser.getSelectedFile().getAbsolutePath();
            } 
   return fname;
      
 }
}